import succinct_common;

real mixgrid = 2.5;
int nmixers = 5;

for (int i = 0; i < nmixers; ++i) {
    real x = mixgrid * i;
    if (i == 3) {
        label((x,0), "$\cdots$");
    } else {
        draw((x, 1.25) -- (x, 0.5), e_arrow);
        label((x, 1.25), "$X$", N);
        mixer(x, 0);
        draw((x, -0.5) -- (x, -1.25), e_arrow);
        label((x, -1.25), (i == 4) ? "$2^{M_n}$" : "$2^{M_"+((string)(i+1))+"}$", S);
    }
}

string[] alphas = {"", "Y_1", "Y_2", "Y_3", "Y_{N-1}", "Y_N"};

for (int i = 1; i < nmixers; ++i) {
    carry_arrow((mixgrid * (i-1), 0), (mixgrid*i, 0), alphas[i]);
}

pair endb = (mixgrid * (nmixers-1), 0) + (0.5,0);
draw(endb -- endb + (0.5,0) {E} .. {S} endb + (1.5,-1) -- endb + (1.5,-1.25), e_arrow);
label(endb + (1.5,-1.25), "$2^{M_{n+1}}$", S);
